<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="units[@size]">
    <units size="{@size - count(unit[@id = 'Default'])}">
        <xsl:apply-templates />
    </units>
</xsl:template>

<xsl:template match="unit[(@id = 'knime') and properties/property[(@name = 'org.eclipse.equinox.p2.type.category') and (@value = 'true')]]/requires">
    <requires size="{@size + 1}">
        <xsl:apply-templates />
        
        <required name="org.knime.product.desktop" namespace="org.eclipse.equinox.p2.iu" range="[0.0.0,99999.9.9]"/>
    </requires>
</xsl:template>

<!-- Remove required entries for source features that do not belong there.
     See https://bugs.eclipse.org/bugs/show_bug.cgi?id=330088
-->
<xsl:template match="unit[contains(@id, '.source.feature.group') or contains(@id, '.source.feature.feature.group')]/requires">
    <xsl:variable name="real-source-entries"
        select="required[(@namespace = 'org.eclipse.equinox.p2.iu') and contains(@name, '.source')]" />
    
    <requires size="{count($real-source-entries)}">
        <xsl:apply-templates select="$real-source-entries" />
    </requires>
</xsl:template>
    

<!-- Remove "Uncategorized" category  -->
<xsl:template match="unit[@id = 'Default']" />

<xsl:template match="@*|node()" priority="-1">
    <xsl:copy><xsl:apply-templates select="@*|node()" /></xsl:copy>
</xsl:template>
</xsl:stylesheet>